﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using KendoTest.Web.Models;
using Kendo.Mvc.UI;
using Kendo.Mvc.Extensions;
        

namespace KendoTest.Web.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

		public JsonResult Occurence_Read([DataSourceRequest]DataSourceRequest request)
		{
			IList<Occurence> resources = new List<Occurence>();

			resources.Add(new Occurence { ThePrimaryId = 1, OccurenceId = 1, OccurenceText = "Resource One", CreatedBy = "chris", CreatedOn = DateTime.Now });
			resources.Add(new Occurence { ThePrimaryId = 2, OccurenceId = 2, OccurenceText = "Resource Two", CreatedBy = "chris", CreatedOn = DateTime.Now });
			resources.Add(new Occurence { ThePrimaryId = 3, OccurenceId = 3, OccurenceText = "Resource Three", CreatedBy = "chris", CreatedOn = DateTime.Now });


			DataSourceResult result = resources.ToDataSourceResult(request);

			return Json(result);
		}

		[AcceptVerbs(HttpVerbs.Post)]
		public ActionResult Occurence_Create([DataSourceRequest] DataSourceRequest request, Occurence occurence)
		{
			if (occurence != null && ModelState.IsValid)
			{
				occurence.CreatedBy = User.Identity.Name;
				//_resourceService.Save(resource);
			}

			return Json(new[] { occurence }.ToDataSourceResult(request, ModelState));
		}

		[HttpGet]
		public JsonResult _AutoComplete_Something(long id, string text)
		{
			//do some kind of auto complete with text
			IList<Occurence> resources = new List<Occurence>();
			if (String.IsNullOrEmpty(text) == false)
			{
				resources.Add(new Occurence { OccurenceId = 1, OccurenceText = "Resource One" });
				resources.Add(new Occurence { OccurenceId = 2, OccurenceText = "Resource Two" });
				resources.Add(new Occurence { OccurenceId = 3, OccurenceText = "Resource Three" });
			}

			return Json(resources, JsonRequestBehavior.AllowGet);
		}

		#region Old Code...


		public JsonResult Experiences_Read([DataSourceRequest]DataSourceRequest request, long id)
		{
			IList<ViewExperience> exps = new List<ViewExperience>();
			exps.Add(new ViewExperience { OccurenceId = 1, ExperienceTitle = "Resource One", ExperienceId = 11 });
			exps.Add(new ViewExperience { OccurenceId = 2, ExperienceTitle = "Resource Two", ExperienceId = 12 });
			exps.Add(new ViewExperience { OccurenceId = 3, ExperienceTitle = "Resource Three", ExperienceId = 13 });

			DataSourceResult result = exps.ToDataSourceResult(request);

			return Json(result);
		}

		//[AcceptVerbs(HttpVerbs.Post)]
		//public ActionResult Resources_Update([DataSourceRequest] DataSourceRequest request, Resource resource)
		//{
		//    if (resource != null && ModelState.IsValid)
		//    {
		//        resource.ModifiedBy = User.Identity.Name;
		//        //_resourceService.Save(resource);
		//    }

		//    return Json(ModelState.ToDataSourceResult());
		//}

		//[AcceptVerbs(HttpVerbs.Post)]
		//public ActionResult Occurence_Destroy([DataSourceRequest] DataSourceRequest request, Occurence occurence)
		//{
		//    try
		//    {
		//        //if (resource != null && resource.ResourceId.HasValue)
		//        //{
		//        //    //_resourceService.Delete(resource.ResourceId.Value);
		//        //}
		//    }
		//    catch (Exception ex)
		//    {
		//        ModelState.AddModelError("ResourceId", ex.Message);
		//    }

		//    return Json(ModelState.ToDataSourceResult());
		//}

		//[AcceptVerbs(HttpVerbs.Post)]
		//public ActionResult Experiences_Destroy([DataSourceRequest] DataSourceRequest request, ViewExperience experience)
		//{
		//    if (experience != null && experience.ExperienceId.HasValue)
		//    {
		//        //experience.ModifiedBy = User.Identity.Name;
		//        //_experienceService.Delete(experience);
		//    }

		//    return Json(ModelState.ToDataSourceResult());
		//}
		#endregion

		
	}
}
